<template>
  <div>
    <br />
    <MainStats v-bind:selectedMonth="selectedMonth"></MainStats>
    <div class="row mt-5">
      <div class="col-md-12">
        <div class="card">
          <div class="card-header">
            <h3 class="card-title">Transactions</h3>
            <div class="card-tools">
              <button class="btn btn-success add-new-btn" @click="newModal">
                Add New &nbsp;
                <i class="fas fa-plus"></i>
              </button>
              <button
                class="btn btn-success"
                @click="showWizard = true"
                type="button"
              >
                Import transactions &nbsp;
                <i class="fas fa-upload"></i>
              </button>
            </div>
          </div>
          <!-- /.card-header -->
          <div class="card-body table-responsive p-0">
            <table class="table table-hover table-striped">
              <tbody>
                <tr>
                  <th>Beneficiary</th>
                  <th>Amount sum, €</th>
                  <th>Date</th>
                  <th>Components</th>
                  <th>Edit / Delete</th>
                </tr>
                <tr v-for="transaction in transactions.data" :key="transaction.id">
                  <td>{{ transaction.custom_beneficiary.name}}</td>
                  <td>{{ getAmountsSum(transaction) }} €</td>
                  <td>{{ transaction.date }}</td>
                  <td>
                    <ul class="components-list">
                      <li
                        v-for="(transactionComponent,index) in transaction.transaction_components"
                        :key="index++"
                      >{{transactionComponent.component_category.name }} {{ transactionComponent.amount }} €</li>
                    </ul>
                  </td>
                  <td>
                    <a href="#" @click="editModal(transaction)">
                      <i class="fa fa-edit blue"></i>
                    </a>

                    <a href="#" @click="deleteTransaction(transaction.id)">
                      <i class="fa fa-trash red"></i>
                    </a>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
          <!-- /.card-body -->
          <div class="card-footer">
            <pagination :data="transactions" @pagination-change-page="getResults"></pagination>
          </div>
        </div>
        <TransactionsImport v-bind:openWizard="showWizard" v-bind:categories="categories"></TransactionsImport>
        <!-- /.card -->
      </div>
    </div>

    <div v-if="!$gate.isAdminOrUser()">
      <not-found></not-found>
    </div>

    <!-- Modal -->
    <div
      class="modal fade"
      id="addNew"
      tabindex="-1"
      role="dialog"
      aria-labelledby="addNewLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" v-show="!editmode" id="addNewLabel">Add New</h5>
            <h5 class="modal-title" v-show="editmode" id="addNewLabel">Update Transaction's Info</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <form @submit.prevent="editmode ? updateTransaction() : createTransaction()">
            <div class="modal-body">
              <div class="form-group">
                <label for="beneficiary">Beneficiary</label>
                <input
                  id="beneficiary"
                  v-model="transactionForm.beneficiary"
                  type="text"
                  name="beneficiary"
                  placeholder="Beneficiary"
                  class="form-control"
                  :class="{ 'is-invalid': transactionForm.errors.has('beneficiary') }"
                />

                <div class="help-block invalid-feedback">The beneficiary field is required.</div>
              </div>

              <div class="form-group">
                <label for="date">Transaction date</label>
                <br />
                <date-picker
                  :class="{ 'is-invalid': transactionForm.errors.has('date') }"
                  id="date"
                  class="date-picker"
                  v-model="transactionForm.date"
                  lang="en"
                  type="date"
                  format="YYYY-MM-DD"
                ></date-picker>
                <div class="help-block invalid-feedback">The date field is required.</div>
              </div>

              <button class="btn btn-success" type="button" @click="appendTransactionComponent">
                Add component
                <i class="fas fa-plus"></i>
              </button>
              <br />
              <br />
              <div
                v-for="(item,index) in transactionForm.transactionComponents"
                v-bind:key="index++"
              >
                <h5>
                  {{ index }}. Component
                  <a
                    v-if="transactionForm.transactionComponents.length>1"
                    href="#"
                    @click="deleteComponent(index-1,item.id)"
                  >
                    <i class="fa fa-trash red"></i>
                  </a>
                </h5>
                <div class="form-group">
                  <label for="amount">Amount, €</label>
                  <input
                    v-model="item.amount"
                    id="amount"
                    type="text"
                    name="amount"
                    placeholder="Amount"
                    class="form-control"
                    :class="{ 'is-invalid': checkError(index-1, 'amount') }"
                  />
                  <div
                    class="help-block invalid-feedback"
                  >The amount field is required and must be a number</div>
                </div>

                <div class="form-group">
                  <label for="category_name">Category name</label>

                  <select
                    class="form-control"
                    v-model="item.category_id"
                    :class="{ 'is-invalid': checkError(index-1, 'category_id') }"
                  >
                    <option disabled value>Please select one</option>
                    <option
                      v-for="category in categories"
                      v-bind:value="category.id"
                      v-bind:key="category.id"
                    >{{ category.name }}</option>
                  </select>
                  <div class="help-block invalid-feedback">The category field is required</div>
                </div>
              </div>

              <form @submit.prevent="createCategory()">
                <h5>Create category</h5>
                <div class="form-group">
                  <label for="name">Name</label>
                  <input
                    v-model="categoryForm.name"
                    id="name"
                    type="text"
                    name="name"
                    placeholder="name"
                    class="form-control"
                    :class="{ 'is-invalid': categoryForm.errors.has('name') }"
                  />
                  <has-error :form="categoryForm" field="name"></has-error>
                </div>
                <button type="submit" class="btn btn-success">Create category</button>
              </form>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              <button v-show="editmode" type="submit" class="btn btn-success">Update</button>
              <button v-show="!editmode" type="submit" class="btn btn-success">Create transaction</button>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import TransactionsImport from "./TransactionsImport";
import MainStats from "./report/MainStats.vue";
export default {
  components: {
    TransactionsImport,
    MainStats
  },
  data() {
    return {
      selectedMonth: moment(new Date()).format("YYYY-MM"),
      editmode: false,
      categories: null,
      transactions: {},
      showWizard: false,
      component: { id: null, category_id: "", amount: null },
      categoryForm: new Form({ name: null }),
      transactionForm: new Form({
        componentsToDelete: [],
        beneficiary: null,
        beneficiary_id: null,
        date: null,
        id: null,
        transactionComponents: []
      })
    };
  },

  methods: {
    createCategory() {
      this.$Progress.start();

      this.categoryForm
        .post("api/component-category")
        .then(() => {
          toast({
            type: "success",
            title: "Category Created in successfully"
          });
          Fire.$emit("GetCategories");
          this.$Progress.finish();
          this.categoryForm.reset();
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },
    checkError(index, label) {
      let line = "transactionComponents." + index + "." + label;
      if (this.transactionForm.errors.has(line)) {
        return true;
      }
      return false;
    },
    getAmountsSum(transaction) {
      let sum = 0;
      transaction.transaction_components.forEach(e => {
        sum += Number(e.amount);
      });
      return sum.toFixed(2);
    },
    appendTransactionComponent() {
      this.transactionForm.transactionComponents.push({
        id: null,
        beneficiary: null,
        category_id: "",
        amount: null,
        date: null
      });
    },
    getResults(page = 1) {
      axios
        .get("api/transaction", {
          params: {
            page: page
          }
        })
        .then(response => {
          this.transactions = response.data;
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },
    updateTransaction() {
      this.$Progress.start();

      this.transactionForm
        .put("api/transaction/" + this.transactionForm.id)
        .then(() => {
          $("#addNew").modal("hide");
          swal("Updated!", "Transaction Created in successfully.", "success");
          Fire.$emit("RefreshTransactions");
          this.$Progress.finish();
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },
    editModal(transaction) {
      this.editmode = true;

      this.transactionForm.reset();

      this.transactionForm.errors.errors = [];

      this.transactionForm.fill(transaction);
      this.transactionForm.beneficiary = transaction.custom_beneficiary.name;

      this.transactionForm.componentsToDelete = [];
      this.transactionForm.transactionComponents = [];
      this.transactionForm.beneficiary_id = transaction.custom_beneficiary.id;

      transaction.transaction_components.forEach(this.setComponentsData);

      this.transactionForm.date = new Date(transaction.date);

      this.resetComponent();
      $("#addNew").modal("show");
    },

    setComponentsData(item, index) {
      this.component.id = item.id;
      this.component.category_id = item.category_id;
      this.component.amount = item.amount;

      this.transactionForm.transactionComponents.push({ ...this.component });
    },

    resetComponent() {
      this.component.amount = null;
      this.component.category_id = "";
      this.component.id = null;
    },
    newModal() {
      this.editmode = false;
      this.transactionForm.reset();
      this.transactionForm;
      this.transactionForm.errors.errors = [];
      this.transactionForm.date = new Date();
      this.transactionForm.transactionComponents.push({ ...this.component });
      $("#addNew").modal("show");
    },
    deleteTransaction(id) {
      swal({
        title: "Are you sure?",
        text: "You won't be able to revert this!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!"
      }).then(result => {
        this.$Progress.start();
        if (result.value) {
          this.transactionForm
            .delete("api/transaction/" + id)
            .then(() => {
              swal(
                "Deleted!",
                "Transaction Deleted in successfully.",
                "success"
              );
              Fire.$emit("RefreshTransactions");
              this.$Progress.finish();
            })
            .catch(error => {
              swal("Failed!", "There was something wrong.", "warning");
              this.$Progress.fail();
              console.log(error);
            });
        }
      });
    },
    loadTransactions() {
      this.$Progress.start();
      axios
        .get("api/transaction")
        .then(response => {
          this.transactions = response.data;
          this.$Progress.finish();
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    createTransaction() {
      this.$Progress.start();

      this.transactionForm
        .post("api/transaction")
        .then(() => {
          Fire.$emit("RefreshTransactions");

          $("#addNew").modal("hide");

          toast({
            type: "success",
            title: "Transaction Created in successfully"
          });
          this.$Progress.finish();
        })
        .catch(() => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
        });
    },

    getCategories() {
      axios
        .get("api/component-category?paginate=0")
        .then(({ data }) => (this.categories = data))
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    deleteComponent(f_id, b_id) {
      if (b_id) {
        this.transactionForm.componentsToDelete.push(b_id);
      }
      this.transactionForm.transactionComponents.splice(f_id, 1);
    }
  },
  created() {
    Fire.$on("searching", () => {
      let query = this.$parent.search;
      axios
        .get("api/find-transaction?q=" + query)
        .then(data => {
          this.transactions = data.data;
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          console.log(error);
        });
    });

    this.getCategories();
    this.loadTransactions();

    Fire.$on("RefreshTransactions", () => {
      this.loadTransactions();
      Fire.$emit("GetSummaryStats");
    });

    Fire.$on("GetCategories", () => {
      this.getCategories();
    });

    Fire.$on("AfterImportComplete", () => {
      this.showWizard = false;
    });
  }
};
</script>